Skip to main content Skip to footer

Expanding FlexGrid Rows to Show Full Text in JavaScript

FlexGrid with row expanded to show full text

Background:

When using Wijmo FlexGrid, some cells may contain long text values that are truncated because rows use a fixed height. In this scenario, users may need a way to expand only the row they are viewing, show the full wrapped text, and then collapse the row again.

FlexGrid does not require the Row Detail plugin for this specific use case. Row Detail is better when you need to show an additional detail panel below a row. For simply showing more text inside the existing cells, a lighter approach is to toggle the row’s wordWrap property and call autoSizeRow for the selected row.

The process involves adding a custom expand/collapse icon to the row header, checking whether the target cell content is overflowing, and resizing the row when the icon is clicked.

Steps to Complete:

  1. Install Wijmo packages.
  2. Import Wijmo styles.
  3. Create a FlexGrid with long text content.
  4. Add row header cells with expand/collapse icons.
  5. Handle icon clicks and toggle row word wrapping.
  6. Auto-size the selected row.

Getting Started:

Install Wijmo packages

Ensure the required Wijmo packages are available in your project.

npm i @mescius/wijmo @mescius/wijmo.styles
  • @mescius/wijmo includes the core Wijmo modules, including FlexGrid.
  • @mescius/wijmo.styles includes the default Wijmo CSS.

 

Import Wijmo styles

Import the Wijmo CSS file in your main JavaScript file.

import '@mescius/wijmo.styles/wijmo.css';
import './style.css';
  • If this step is missed, the grid and built-in Wijmo glyph icons will not display correctly.

 

Create a FlexGrid with long text content

This creates the grid and binds it to data that includes a long text field. In this example, the description column contains text that may be too long to fit inside the default row height.

<div id="theGrid"></div>
import '@mescius/wijmo.styles/wijmo.css';
import './style.css';

import { FlexGrid } from '@mescius/wijmo.grid';

const data = getData(1000);

const grid = new FlexGrid('#theGrid', {
  itemsSource: data
});

function getData(count) {
  const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
  const data = [];

  for (let i = 0; i < count; i++) {
    data.push({
      id: i,
      country: countries[i % countries.length],
      description:
        i % 2 === 0
          ? 'This is a long description designed to overflow the cell text. This is a long description designed to overflow the cell text.'
          : 'Description',
      active: i % 4 === 0
    });
  }

  return data;
}
  • The important part is the description field. That is the column where the text may be truncated and where row expansion becomes useful.

 

Add row header cells with expand/collapse icons

This customizes the row header cells. The code checks whether the target cell content is overflowing. If the row is collapsed and the text overflows, it shows a plus icon. If the row is expanded, it shows a minus icon.

grid.formatItem.addHandler((s, e) => {
  if (e.panel === s.rowHeaders && e.row >= 0) {
    const row = s.rows[e.row];

    e.cell.innerHTML = '';

    if (shouldShowExpandIcon(s, row)) {
      e.cell.innerHTML = '<span class="row-btn wj-glyph-plus" title="Expand row"></span>';
    } else if (shouldShowCollapseIcon(s, row)) {
      e.cell.innerHTML = '<span class="row-btn wj-glyph-minus" title="Collapse row"></span>';
    }
  }
});

function shouldShowExpandIcon(grid, row) {
  return isOverflow(grid, row) && row.renderHeight <= grid.rows.defaultSize;
}

function shouldShowCollapseIcon(grid, row) {
  return row.renderHeight > grid.rows.defaultSize;
}

function isOverflow(grid, row) {
  const targetCols = ['description'];

  for (let i = 0; i < targetCols.length; i++) {
    const col = grid.getColumn(targetCols[i]);

    if (col) {
      const cell = grid.cells.getCellElement(row.index, col.index);

      if (cell && cell.scrollWidth > cell.clientWidth) {
        return true;
      }
    }
  }

  return false;
}

 

Handle icon clicks and toggle row word wrapping

This step listens for clicks inside the grid. When the user clicks the plus or minus icon in the row header, the code finds the clicked row and toggles its wordWrap property.

import { hasClass } from '@mescius/wijmo';

grid.rows.defaultSize = 26;

grid.addEventListener(grid.hostElement, 'click', (e) => {
  const ht = grid.hitTest(e);
  const target = e.target;

  if (hasClass(target, 'row-btn') && ht.panel === grid.rowHeaders) {
    const row = grid.rows[ht.row];

    row.wordWrap = row.renderHeight <= grid.rows.defaultSize;
  }
});
  • If the row is currently collapsed, wordWrap becomes true. If the row is already expanded, wordWrap becomes false.

 

Auto-size the selected row

Toggling wordWrap alone is not enough. The row also needs to be resized so the wrapped text can actually appear. This is where autoSizeRow comes in.

grid.addEventListener(grid.hostElement, 'click', (e) => {
  const ht = grid.hitTest(e);
  const target = e.target;

  if (hasClass(target, 'row-btn') && ht.panel === grid.rowHeaders) {
    const row = grid.rows[ht.row];

    row.wordWrap = row.renderHeight <= grid.rows.defaultSize;

    // Resize only the clicked row.
    grid.autoSizeRow(row.index);
  }
});
  • This keeps the implementation efficient. Do not auto-size every row when the user clicks one icon. That is wasteful, especially with large grids. Resize only the selected row.

 

With this JavaScript setup:

  • Long text rows show an expand icon in the row header.
  • Clicking the icon enables wrapping and auto-sizes that specific row.
  • Clicking again disables wrapping and collapses the row.
  • Rows without overflowing text do not show an icon.
  • The implementation avoids unnecessary row detail panels.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Expanding FlexGrid Rows to Show Full Text in Vue

FlexGrid row expanding to show full text

Background:

When using Wijmo FlexGrid, some cells may contain long text values that are truncated because rows use a fixed height. In this scenario, users may need a way to expand only the row they are viewing, show the full wrapped text, and then collapse the row again.

FlexGrid does not require the Row Detail plugin for this specific use case. Row Detail is better when you need to show an additional detail panel below a row. For simply showing more text inside the existing cells, a lighter approach is to toggle the row’s wordWrap property and call autoSizeRow for the selected row.

The process involves adding a custom expand/collapse icon to the row header, checking whether the target cell content is overflowing, and resizing the row when the icon is clicked.

Steps to Complete:

  1. Install Wijmo packages.
  2. Import Wijmo styles.
  3. Create a FlexGrid with long text content.
  4. Add a row header template with expand/collapse icons.
  5. Handle icon clicks and toggle row word wrapping.
  6. Auto-size the selected row.

Getting Started:

Install Wijmo packages

Ensure the required Wijmo Vue packages are available in your project.

npm i @mescius/wijmo @mescius/wijmo.vue2.grid @mescius/wijmo.styles
  • @mescius/wijmo.vue2.grid includes the Vue wrapper for FlexGrid.
  • @mescius/wijmo includes the core Wijmo utilities.
  • @mescius/wijmo.styles includes the default Wijmo CSS.

 

Import Wijmo styles

Import the Wijmo CSS file in your main entry file.

import { createApp } from 'vue';
import App from './App.vue';

import '@mescius/wijmo.styles/wijmo.css';
import './style.css';

createApp(App).mount('#app');
  • If this step is missed, the grid and built-in Wijmo glyph icons will not display correctly.

 

Create a FlexGrid with long text content

This creates the grid and binds it to data that includes a long text field. In this example, the description column contains text that may be too long to fit inside the default row height.

<template>
  <div class="app">
    <wj-flex-grid :items-source="data">
    </wj-flex-grid>
  </div>
</template>

<script>
import { WjFlexGrid } from '@mescius/wijmo.vue2.grid';

export default {
  name: 'App',

  components: {
    WjFlexGrid
  },

  data() {
    return {
      data: this.getData(1000)
    };
  },

  methods: {
    getData(count) {
      const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
      const data = [];

      for (let i = 0; i < count; i++) {
        data.push({
          id: i,
          country: countries[i % countries.length],
          description:
            i % 2 === 0
              ? 'This is a long description designed to overflow the cell text. This is a long description designed to overflow the cell text.'
              : 'Description',
          active: i % 4 === 0
        });
      }

      return data;
    }
  }
};
</script>

 

Add a row header template with expand/collapse icons

This adds a custom template to the row header. The template checks whether the target cell content is overflowing. If the row is collapsed and the text overflows, it shows a plus icon. If the row is expanded, it shows a minus icon.

<template>
  <div class="app">
    <wj-flex-grid
      :items-source="data"
      :virtualization-threshold="[0, 50]"
      :initialized="initGrid"
    >
      <wj-flex-grid-cell-template
        cellType="RowHeader"
        v-slot="cell"
      >
        <span
          v-if="shouldShowExpandIcon(cell.row)"
          class="row-btn wj-glyph-plus"
          title="Expand row"
        ></span>

        <span
          v-if="shouldShowCollapseIcon(cell.row)"
          class="row-btn wj-glyph-minus"
          title="Collapse row"
        ></span>
      </wj-flex-grid-cell-template>
    </wj-flex-grid>
  </div>
</template>

<script>
import { WjFlexGrid, WjFlexGridCellTemplate } from '@mescius/wijmo.vue2.grid';

export default {
  name: 'App',

  components: {
    WjFlexGrid,
    WjFlexGridCellTemplate
  },

  data() {
    return {
      data: this.getData(1000),
      grid: null
    };
  },

  methods: {
    shouldShowExpandIcon(row) {
      if (!this.grid || !row) {
        return false;
      }

      return this.isOverflow(row) && row.renderHeight <= this.grid.rows.defaultSize;
    },

    shouldShowCollapseIcon(row) {
      if (!this.grid || !row) {
        return false;
      }

      return row.renderHeight > this.grid.rows.defaultSize;
    },

    isOverflow(row) {
      const targetCols = ['description'];

      for (let i = 0; i < targetCols.length; i++) {
        const col = this.grid.getColumn(targetCols[i]);

        if (col) {
          const cell = this.grid.cells.getCellElement(row.index, col.index);

          if (cell && cell.scrollWidth > cell.clientWidth) {
            return true;
          }
        }
      }

      return false;
    },

    getData(count) {
      const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
      const data = [];

      for (let i = 0; i < count; i++) {
        data.push({
          id: i,
          country: countries[i % countries.length],
          description:
            i % 2 === 0
              ? 'This is a long description designed to overflow the cell text. This is a long description designed to overflow the cell text.'
              : 'Description',
          active: i % 4 === 0
        });
      }

      return data;
    }
  }
};
</script>

 

Handle icon clicks and toggle row word wrapping

This listens for clicks inside the grid. When the user clicks the plus or minus icon in the row header, the code finds the clicked row and toggles its wordWrap property.

<script>
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid';

export default {
  name: 'App',

  data() {
    return {
      data: this.getData(1000),
      grid: null
    };
  },

  methods: {
    initGrid(grid) {
      this.grid = grid;

      grid.rows.defaultSize = 26;

      grid.addEventListener(grid.hostElement, 'click', (e) => {
        const ht = grid.hitTest(e);
        const target = e.target;

        if (wjCore.hasClass(target, 'row-btn') && ht.panel === grid.rowHeaders) {
          const row = grid.rows[ht.row];

          row.wordWrap = row.renderHeight <= grid.rows.defaultSize;
        }
      });
    },

    getData(count) {
      const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
      const data = [];

      for (let i = 0; i < count; i++) {
        data.push({
          id: i,
          country: countries[i % countries.length],
          description:
            i % 2 === 0
              ? 'This is a long description designed to overflow the cell text. This is a long description designed to overflow the cell text.'
              : 'Description',
          active: i % 4 === 0
        });
      }

      return data;
    }
  }
};
</script>
  • If the row is currently collapsed, wordWrap becomes true. If the row is already expanded, wordWrap becomes false.

 

Auto-size the selected row.

Toggling wordWrap alone is not enough. The row also needs to be resized so the wrapped text can actually appear. This is where autoSizeRow comes in.

initGrid(grid) {
  this.grid = grid;

  grid.rows.defaultSize = 26;

  grid.addEventListener(grid.hostElement, 'click', (e) => {
    const ht = grid.hitTest(e);
    const target = e.target;

    if (wjCore.hasClass(target, 'row-btn') && ht.panel === grid.rowHeaders) {
      const row = grid.rows[ht.row];

      row.wordWrap = row.renderHeight <= grid.rows.defaultSize;

      // Resize only the clicked row.
      grid.autoSizeRow(row.index);
    }
  });
}
  • Use grid.autoSizeRow(row.index); immediately after changing row.wordWrap

 

With this Vue setup:

  • Long text rows show an expand icon in the row header.
  • Clicking the icon enables wrapping and auto-sizes that specific row.
  • Clicking again disables wrapping and collapses the row.
  • Rows without overflowing text do not show an icon.
  • The implementation avoids unnecessary row detail panels.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Expanding FlexGrid Rows to Show Full Text in Angular

FlexGrid with expanded row to show full text

Background:

When using Wijmo FlexGrid, some cells may contain long text values that are truncated because rows use a fixed height. In this scenario, users may need a way to expand only the row they are viewing, show the full wrapped text, and then collapse the row again.

FlexGrid does not require the Row Detail plugin for this specific use case. Row Detail is better when you need to show an additional detail panel below a row. For simply showing more text inside the existing cells, a lighter approach is to toggle the row’s wordWrap property and call autoSizeRow for the selected row.

The process involves adding a custom expand/collapse icon to the row header, checking whether the target cell content is overflowing, and resizing the row when the icon is clicked.

Steps to Complete:

  1. Install Wijmo packages.
  2. Import Wijmo styles.
  3. Create a FlexGrid with long text content.
  4. Add a row header template with expand/collapse icons.
  5. Handle icon clicks and toggle row word wrapping.
  6. Auto-size the selected row.

Getting Started:

Install Wijmo packages

Ensure the required Wijmo Angular packages are available in your project.

npm i @mescius/wijmo @mescius/wijmo.angular2.grid @mescius/wijmo.styles
  • @mescius/wijmo.angular2.grid includes the Angular wrapper for FlexGrid.
  • @mescius/wijmo includes the core Wijmo utilities.
  • @mescius/wijmo.styles includes the default Wijmo CSS.

 

Import Wijmo styles

Add the Wijmo CSS file to your project. This can be done in angular.json:

"styles": [
  "node_modules/@mescius/wijmo.styles/wijmo.css",
  "src/styles.css"
]

Or import it directly in styles.css:

@import '@mescius/wijmo.styles/wijmo.css';
  • If this step is missed, the grid and built-in Wijmo glyph icons will not display correctly.

 

Create a FlexGrid with long text content

This step creates the grid and binds it to data that includes a long text field. In this example, the description column contains text that may be too long to fit inside the default row height.

// app.component.ts
import { Component } from '@angular/core';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html'
})
export class AppComponent {
  data = this.getData(1000);

  getData(count: number) {
    const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
    const data = [];

    for (let i = 0; i < count; i++) {
      data.push({
        id: i,
        country: countries[i % countries.length],
        description:
          i % 2 === 0
            ? 'This is a long description designed to overflow the cell text. This is a long description designed to overflow the cell text.'
            : 'Description',
        active: i % 4 === 0
      });
    }

    return data;
  }
}

 

Add a row header template with expand/collapse icons

This adds a custom template to the row header. The template checks whether the target cell content is overflowing. If the row is collapsed and the text overflows, it shows a plus icon. If the row is expanded, it shows a minus icon.

<!-- app.component.html -->
<wj-flex-grid
  #flexGrid
  [itemsSource]="data"
  [virtualizationThreshold]="[0, 50]"
  (initialized)="initGrid(flexGrid)"
>
  <wj-flex-grid-cell-template
    cellType="RowHeader"
    let-cell="cell"
    let-row="row"
  >
    <span
      *ngIf="shouldShowExpandIcon(row)"
      class="row-btn wj-glyph-plus"
      title="Expand row"
    ></span>

    <span
      *ngIf="shouldShowCollapseIcon(row)"
      class="row-btn wj-glyph-minus"
      title="Collapse row"
    ></span>
  </wj-flex-grid-cell-template>
</wj-flex-grid>
// app.component.ts
import { Component } from '@angular/core';
import * as wjGrid from '@mescius/wijmo.grid';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html'
})
export class AppComponent {
  data = this.getData(1000);
  grid!: wjGrid.FlexGrid;

  shouldShowExpandIcon(row: wjGrid.Row): boolean {
    if (!this.grid || !row) {
      return false;
    }

    return this.isOverflow(row) && row.renderHeight <= this.grid.rows.defaultSize;
  }

  shouldShowCollapseIcon(row: wjGrid.Row): boolean {
    if (!this.grid || !row) {
      return false;
    }

    return row.renderHeight > this.grid.rows.defaultSize;
  }

  private isOverflow(row: wjGrid.Row): boolean {
    const targetCols = ['description'];

    for (let i = 0; i < targetCols.length; i++) {
      const col = this.grid.getColumn(targetCols[i]);

      if (col) {
        const cell = this.grid.cells.getCellElement(row.index, col.index);

        if (cell && cell.scrollWidth > cell.clientWidth) {
          return true;
        }
      }
    }

    return false;
  }

  getData(count: number) {
    const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
    const data = [];

    for (let i = 0; i < count; i++) {
      data.push({
        id: i,
        country: countries[i % countries.length],
        description:
          i % 2 === 0
            ? 'This is a long description designed to overflow the cell text. This is a long description designed to overflow the cell text.'
            : 'Description',
        active: i % 4 === 0
      });
    }

    return data;
  }
}

 

Handle icon clicks and toggle row word wrapping

This listens for clicks inside the grid. When the user clicks the plus or minus icon in the row header, the code finds the clicked row and toggles its wordWrap property.

// app.component.ts
...

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html'
})
export class AppComponent {
  data = this.getData(1000);
  grid!: wjGrid.FlexGrid;

  initGrid(grid: wjGrid.FlexGrid) {
    this.grid = grid;

    grid.rows.defaultSize = 26;

    grid.addEventListener(grid.hostElement, 'click', (e: MouseEvent) => {
      const ht = grid.hitTest(e);
      const target = e.target as HTMLElement;

      if (wjCore.hasClass(target, 'row-btn') && ht.panel === grid.rowHeaders) {
        const row = grid.rows[ht.row];

        row.wordWrap = row.renderHeight <= grid.rows.defaultSize;
      }
    });
  }

  getData(count: number) {
    const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
    const data = [];

    for (let i = 0; i < count; i++) {
      data.push({
        id: i,
        country: countries[i % countries.length],
        description:
          i % 2 === 0
            ? 'This is a long description designed to overflow the cell text. This is a long description designed to overflow the cell text.'
            : 'Description',
        active: i % 4 === 0
      });
    }

    return data;
  }
}
  • If the row is currently collapsed, wordWrap becomes true. If the row is already expanded, wordWrap becomes false.

 

Auto-size the selected row

Toggling wordWrap alone is not enough. The row also needs to be resized so the wrapped text can actually appear. This is where autoSizeRow comes in.

initGrid(grid: wjGrid.FlexGrid) {
  this.grid = grid;

  grid.rows.defaultSize = 26;

  grid.addEventListener(grid.hostElement, 'click', (e: MouseEvent) => {
    const ht = grid.hitTest(e);
    const target = e.target as HTMLElement;

    if (wjCore.hasClass(target, 'row-btn') && ht.panel === grid.rowHeaders) {
      const row = grid.rows[ht.row];

      row.wordWrap = row.renderHeight <= grid.rows.defaultSize;

      // Resize only the clicked row.
      grid.autoSizeRow(row.index);
    }
  });
}
  • grid.autoSizeRow(row.index); use it immediately after changing row.wordWrap

 

With this Angular setup:

  • Long text rows show an expand icon in the row header.
  • Clicking the icon enables wrapping and auto-sizes that specific row.
  • Clicking again disables wrapping and collapses the row.
  • Rows without overflowing text do not show an icon.
  • The implementation avoids unnecessary row detail panels.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Expanding FlexGrid Rows to Show Full Text in React

FlexGrid row expanded to show full text

Background:

When using Wijmo FlexGrid, some cells may contain long text values that are truncated because rows use a fixed height. In this scenario, users may need a way to expand only the row they are viewing, show the full wrapped text, and then collapse the row again.

FlexGrid does not require the Row Detail plugin for this specific use case. Row Detail is better when you need to show an additional detail panel below a row. For simply showing more text inside the existing cells, a lighter approach is to toggle the row’s wordWrap property and call autoSizeRow for the selected row.

The process involves adding a custom expand/collapse icon to the row header, checking whether the target cell content is overflowing, and resizing the row when the icon is clicked.

Steps to Complete:

  1. Install Wijmo packages.
  2. Import Wijmo styles.
  3. Create a FlexGrid with long text content.
  4. Add a row header template with expand/collapse icons.
  5. Handle icon clicks and toggle row word wrapping.
  6. Auto-size the selected row.

Getting Started:

Install Wijmo packages

Ensure the required Wijmo React packages are available in your project.

npm i @mescius/wijmo @mescius/wijmo.react.grid @mescius/wijmo.styles
  • @mescius/wijmo.react.grid includes the React wrapper for FlexGrid.
  • @mescius/wijmo includes the core Wijmo utilities.
  • @mescius/wijmo.styles includes the default Wijmo CSS.

 

Import Wijmo styles

This loads the default styling required by Wijmo controls.

import '@mescius/wijmo.styles/wijmo.css';
  • If this step is missed, the grid and built-in Wijmo glyph icons will not display correctly.

 

Create sample data

This creates a dataset where every other row contains a long description value.

function getData(count) {
  const countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
  const data = [];

  for (let i = 0; i < count; i++) {
    data.push({
      id: i,
      country: countries[i % countries.length],
      description:
        i % 2 === 0
          ? 'This is a long description for the countries, designed to overflow the cell text. This is a long description for the countries, designed to overflow the cell text.'
          : 'Description',
      active: i % 4 === 0,
    });
  }

  return data;
}
  • The description field is the target column.
  • Long descriptions will be truncated when the row height is fixed.
  • Short descriptions do not need an expand icon.

 

Create a FlexGrid with long text content

This creates the grid and binds it to data that includes a long text field. The description column contains text that may be too long to fit inside the default row height.

import React from 'react';
import { FlexGrid } from '@mescius/wijmo.react.grid';

const ExpandableRowsGrid = ({ data }) => {
  return (
    <FlexGrid itemsSource={data}>
      {/* Grid columns can be auto-generated, or you can define them manually */}
    </FlexGrid>
  );
};

export default ExpandableRowsGrid;

 

Add a row header template with expand/collapse icons

This adds a custom template to the row header. The template checks whether the target cell content is overflowing. If the row is collapsed and the text overflows, it shows a plus icon. If the row is expanded, it shows a minus icon.

import { FlexGrid, FlexGridCellTemplate } from '@mescius/wijmo.react.grid';

const rowHeaderTemplate = (ctx) => {
  const grid = ctx.row.grid;
  const row = ctx.row;
  const targetCols = ['description'];

  let isOverflow = false;

  for (let i = 0; i < targetCols.length; i++) {
    const col = grid.getColumn(targetCols[i]);

    if (col) {
      const cell = grid.cells.getCellElement(row.index, col.index);

      if (cell) {
        isOverflow = cell.scrollWidth > cell.clientWidth;
      }

      if (isOverflow) {
        break;
      }
    }
  }

  if (isOverflow && row.renderHeight <= grid.rows.defaultSize) {
    return <span className="row-btn wj-glyph-plus" title="Expand row"></span>;
  }

  if (row.renderHeight > grid.rows.defaultSize) {
    return <span className="row-btn wj-glyph-minus" title="Collapse row"></span>;
  }

  return null;
};

Use the template inside the grid:

<FlexGrid itemsSource={data}>
  <FlexGridCellTemplate
    cellType="RowHeader"
    template={rowHeaderTemplate}
    autoSizeRows={false}
  />
</FlexGrid>
  • The row header template checks whether the description cell is overflowing.
  • wj-glyph-plus displays the expand icon.
  • wj-glyph-minus displays the collapse icon.

 

Handle icon clicks and toggle row word wrapping

This listens for clicks inside the grid. When the user clicks the plus or minus icon in the row header, the code finds the clicked row and toggles its wordWrap property.

import * as wjCore from '@mescius/wijmo';

const initGrid = (grid) => {
  grid.rows.defaultSize = 26;

  grid.addEventListener(grid.hostElement, 'click', (e) => {
    const ht = grid.hitTest(e);
    const target = e.target;

    if (wjCore.hasClass(target, 'row-btn') && ht.panel === grid.rowHeaders) {
      const row = grid.rows[ht.row];

      row.wordWrap = row.renderHeight <= grid.rows.defaultSize;
    }
  });
};

Attach initGrid to the initialized event:

<FlexGrid
  itemsSource={data}
  initialized={initGrid}
>
  <FlexGridCellTemplate
    cellType="RowHeader"
    template={rowHeaderTemplate}
    autoSizeRows={false}
  />
</FlexGrid>
  • row.wordWrap controls whether text wraps inside the selected row.

 

Auto-size the selected row

Toggling wordWrap alone is not enough. The row also needs to be resized so the wrapped text can actually appear. This is where autoSizeRow comes in.

const initGrid = (grid) => {
  grid.rows.defaultSize = 26;

  grid.addEventListener(grid.hostElement, 'click', (e) => {
    const ht = grid.hitTest(e);
    const target = e.target;

    if (wjCore.hasClass(target, 'row-btn') && ht.panel === grid.rowHeaders) {
      const row = grid.rows[ht.row];

      row.wordWrap = row.renderHeight <= grid.rows.defaultSize;

      // Resize only the clicked row.
      grid.autoSizeRow(row.index);
    }
  });
};
  • grid.autoSizeRow(row.index) resizes only the clicked row.

 

With this React setup:

  • Long text rows show an expand icon in the row header.
  • Clicking the icon enables wrapping and auto-sizes that specific row.
  • Clicking again disables wrapping and collapses the row.
  • Rows without overflowing text do not show an icon.
  • The implementation avoids unnecessary row detail panels.

Happy coding!

Andrew Peterson

Technical Engagement Engineer